<?php 
/**
 * Leave_requests_accept_reject Page Controller
 * @category  Controller
 */
class Leave_requests_accept_rejectController extends SecureController{
	function __construct(){
		parent::__construct();
		$this->tablename = "leave_requests_accept_reject";
	}
	/**
     * List page records
     * @param $fieldname (filter record by a field) 
     * @param $fieldvalue (filter field value)
     * @return BaseView
     */
	function index($fieldname = null , $fieldvalue = null){
		$request = $this->request;
		$db = $this->GetModel();
		$tablename = $this->tablename;
		$fields = array("leave_requests_accept_reject.id", 
			"leave_requests_accept_reject.remark", 
			"leave_requests_accept_reject.stage", 
			"leave_requests_accept_reject.status_acc", 
			"leave_requests.reason AS leave_requests_reason", 
			"leave_requests.files AS leave_requests_files", 
			"leave_requests.actual_leave_days AS leave_requests_actual_leave_days", 
			"leave_requests.holiday_dates AS leave_requests_holiday_dates", 
			"leave_requests.holiday_type AS leave_requests_holiday_type", 
			"employee_details.employee_name AS employee_details_employee_name", 
			"employee_details.department AS employee_details_department", 
			"employee_details.designation AS employee_details_designation");
		$pagination = $this->get_pagination(MAX_RECORD_COUNT); // get current pagination e.g array(page_number, page_limit)
		//search table record
		if(!empty($request->search)){
			$text = trim($request->search); 
			$search_condition = "(
				leave_requests_accept_reject.id LIKE ? OR 
				leave_requests_accept_reject.rec_id LIKE ? OR 
				leave_requests_accept_reject.app_userid LIKE ? OR 
				leave_requests_accept_reject.remark LIKE ? OR 
				leave_requests_accept_reject.stage LIKE ? OR 
				leave_requests_accept_reject.status_acc LIKE ? OR 
				leave_requests_accept_reject.timestamp LIKE ? OR 
				leave_requests.id LIKE ? OR 
				leave_requests.emp_id LIKE ? OR 
				leave_requests.status LIKE ? OR 
				leave_requests.reason LIKE ? OR 
				leave_requests.files LIKE ? OR 
				leave_requests.actual_leave_days LIKE ? OR 
				leave_requests.holiday_dates LIKE ? OR 
				leave_requests.holiday_type LIKE ? OR 
				employee_details.id LIKE ? OR 
				employee_details.employee_name LIKE ? OR 
				employee_details.portfolio_id LIKE ? OR 
				employee_details.basic_pay LIKE ? OR 
				employee_details.bank_acc_no LIKE ? OR 
				employee_details.bank_name LIKE ? OR 
				employee_details.email LIKE ? OR 
				employee_details.dob LIKE ? OR 
				employee_details.date_of_join LIKE ? OR 
				employee_details.date_of_retirement LIKE ? OR 
				employee_details.department LIKE ? OR 
				employee_details.IFSC LIKE ? OR 
				employee_details.designation LIKE ? OR 
				employee_details.caste LIKE ? OR 
				employee_details.relegion LIKE ? OR 
				employee_details.nominee LIKE ? OR 
				employee_details.payscale LIKE ? OR 
				employee_details.gender LIKE ? OR 
				employee_details.identification_mark LIKE ? OR 
				employee_details.place_of_birth LIKE ? OR 
				employee_details.balanceleave LIKE ? OR 
				employee_details.mobile LIKE ? OR 
				employee_details.photo LIKE ? OR 
				employee_details.handicapped LIKE ? OR 
				employee_details.blind LIKE ? OR 
				employee_details.employee_type LIKE ? OR 
				employee_details.service_book LIKE ? OR 
				employee_details.service_book_remark LIKE ?
			)";
			$search_params = array(
				"%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%"
			);
			//setting search conditions
			$db->where($search_condition, $search_params);
			 //template to use when ajax search
			$this->view->search_template = "leave_requests_accept_reject/search.php";
		}
		$db->join("leave_requests", "leave_requests_accept_reject.rec_id = leave_requests.id", "LEFT");
		$db->join("employee_details", "leave_requests.emp_id = employee_details.id", "LEFT");
		if(!empty($request->orderby)){
			$orderby = $request->orderby;
			$ordertype = (!empty($request->ordertype) ? $request->ordertype : ORDER_TYPE);
			$db->orderBy($orderby, $ordertype);
		}
		else{
			$db->orderBy("leave_requests_accept_reject.id", ORDER_TYPE);
		}
		$db->where("leave_requests_accept_reject.app_userid='".USER_ID."'");
		if($fieldname){
			$db->where($fieldname , $fieldvalue); //filter by a single field name
		}
		$tc = $db->withTotalCount();
		$records = $db->get($tablename, $pagination, $fields);
		$records_count = count($records);
		$total_records = intval($tc->totalCount);
		$page_limit = $pagination[1];
		$total_pages = ceil($total_records / $page_limit);
		$data = new stdClass;
		$data->records = $records;
		$data->record_count = $records_count;
		$data->total_records = $total_records;
		$data->total_page = $total_pages;
		if($db->getLastError()){
			$this->set_page_error();
		}
		$page_title = $this->view->page_title = "Leave Requests Accept Reject";
		$this->view->report_filename = date('Y-m-d') . '-' . $page_title;
		$this->view->report_title = $page_title;
		$this->view->report_layout = "report_layout.php";
		$this->view->report_paper_size = "A4";
		$this->view->report_orientation = "portrait";
		$this->render_view("leave_requests_accept_reject/list.php", $data); //render the full page
	}
	/**
     * View record detail 
	 * @param $rec_id (select record by table primary key) 
     * @param $value value (select record by value of field name(rec_id))
     * @return BaseView
     */
	function view($rec_id = null, $value = null){
		$request = $this->request;
		$db = $this->GetModel();
		$rec_id = $this->rec_id = urldecode($rec_id);
		$tablename = $this->tablename;
		$fields = array("leave_requests_accept_reject.id", 
			"leave_requests_accept_reject.rec_id", 
			"leave_requests_accept_reject.app_userid", 
			"leave_requests_accept_reject.remark", 
			"leave_requests_accept_reject.stage", 
			"leave_requests_accept_reject.status_acc", 
			"leave_requests_accept_reject.timestamp", 
			"leave_requests.id AS leave_requests_id", 
			"leave_requests.emp_id AS leave_requests_emp_id", 
			"leave_requests.status AS leave_requests_status", 
			"leave_requests.reason AS leave_requests_reason", 
			"leave_requests.files AS leave_requests_files", 
			"leave_requests.actual_leave_days AS leave_requests_actual_leave_days", 
			"leave_requests.holiday_dates AS leave_requests_holiday_dates", 
			"leave_requests.holiday_type AS leave_requests_holiday_type", 
			"employee_details.id AS employee_details_id", 
			"employee_details.employee_name AS employee_details_employee_name", 
			"employee_details.portfolio_id AS employee_details_portfolio_id", 
			"employee_details.basic_pay AS employee_details_basic_pay", 
			"employee_details.bank_acc_no AS employee_details_bank_acc_no", 
			"employee_details.bank_name AS employee_details_bank_name", 
			"employee_details.email AS employee_details_email", 
			"employee_details.dob AS employee_details_dob", 
			"employee_details.date_of_join AS employee_details_date_of_join", 
			"employee_details.date_of_retirement AS employee_details_date_of_retirement", 
			"employee_details.department AS employee_details_department", 
			"employee_details.IFSC AS employee_details_IFSC", 
			"employee_details.designation AS employee_details_designation", 
			"employee_details.caste AS employee_details_caste", 
			"employee_details.relegion AS employee_details_relegion", 
			"employee_details.nominee AS employee_details_nominee", 
			"employee_details.payscale AS employee_details_payscale", 
			"employee_details.gender AS employee_details_gender", 
			"employee_details.identification_mark AS employee_details_identification_mark", 
			"employee_details.place_of_birth AS employee_details_place_of_birth", 
			"employee_details.balanceleave AS employee_details_balanceleave", 
			"employee_details.mobile AS employee_details_mobile", 
			"employee_details.photo AS employee_details_photo", 
			"employee_details.handicapped AS employee_details_handicapped", 
			"employee_details.blind AS employee_details_blind", 
			"employee_details.employee_type AS employee_details_employee_type", 
			"employee_details.service_book AS employee_details_service_book", 
			"employee_details.service_book_remark AS employee_details_service_book_remark", 
			"user_info.id AS user_info_id", 
			"user_info.username AS user_info_username", 
			"user_info.password AS user_info_password", 
			"user_info.email AS user_info_email", 
			"user_info.user_full_name AS user_info_user_full_name", 
			"user_info.user_role_id AS user_info_user_role_id");
		if($value){
			$db->where($rec_id, urldecode($value)); //select record based on field name
		}
		else{
			$db->where("leave_requests_accept_reject.id", $rec_id);; //select record based on primary key
		}
		$db->join("user_info", "leave_requests_accept_reject.app_userid = user_info.id", "LEFT ");  
		$record = $db->getOne($tablename, $fields );
		if($record){
			$page_title = $this->view->page_title = "View  Leave Requests Accept Reject";
		$this->view->report_filename = date('Y-m-d') . '-' . $page_title;
		$this->view->report_title = $page_title;
		$this->view->report_layout = "report_layout.php";
		$this->view->report_paper_size = "A4";
		$this->view->report_orientation = "portrait";
		}
		else{
			if($db->getLastError()){
				$this->set_page_error();
			}
			else{
				$this->set_page_error("No record found");
			}
		}
		return $this->render_view("leave_requests_accept_reject/view.php", $record);
	}
	/**
     * Insert new record to the database table
	 * @param $formdata array() from $_POST
     * @return BaseView
     */
	function add($formdata = null){
		if($formdata){
			$db = $this->GetModel();
			$tablename = $this->tablename;
			$request = $this->request;
			//fillable fields
			$fields = $this->fields = array();
			$postdata = $this->format_request_data($formdata);
			$this->rules_array = array(
			);
			$this->sanitize_array = array(
			);
			$this->filter_vals = true; //set whether to remove empty fields
			$modeldata = $this->modeldata = $this->validate_form($postdata);
			if($this->validated()){
				$rec_id = $this->rec_id = $db->insert($tablename, $modeldata);
				if($rec_id){
					$this->set_flash_msg("Record added successfully", "success");
					return	$this->redirect("leave_requests_accept_reject");
				}
				else{
					$this->set_page_error();
				}
			}
		}
		$page_title = $this->view->page_title = "Add New Leave Requests Accept Reject";
		$this->render_view("leave_requests_accept_reject/add.php");
	}
	/**
     * Update table record with formdata
	 * @param $rec_id (select record by table primary key)
	 * @param $formdata array() from $_POST
     * @return array
     */
	function edit($rec_id = null, $formdata = null){
		$request = $this->request;
		$db = $this->GetModel();
		$this->rec_id = $rec_id;
		$tablename = $this->tablename;
		 //editable fields
		$fields = $this->fields = array("id","remark","stage","status_acc");
		if($formdata){
			$postdata = $this->format_request_data($formdata);
			$this->rules_array = array(
				'remark' => 'required',
				'stage' => 'required',
				'status_acc' => 'required',
			);
			$this->sanitize_array = array(
				'remark' => 'sanitize_string',
				'stage' => 'sanitize_string',
				'status_acc' => 'sanitize_string',
			);
			$modeldata = $this->modeldata = $this->validate_form($postdata);
			if($this->validated()){
				$db->where("leave_requests_accept_reject.id", $rec_id);;
				$bool = $db->update($tablename, $modeldata);
				$numRows = $db->getRowCount(); //number of affected rows. 0 = no record field updated
				if($bool && $numRows){
		# Statement to execute after adding record
			$db->where("id", $rec_id);
    $rec_id = $db->getValue("leave_requests_accept_reject", "rec_id");
    // print_r($rec_id);
    // exit();
    if($modeldata['status_acc']=="ACCEPT"){
    $db->where("sequence", $modeldata['stage']+1);
    $app_user_id = $db->getValue("autorization", "IFNULL(user,0)");
    if($app_user_id!=0){
    $table_data = array(
    "rec_id" => $rec_id, 
    "app_userid" => "$app_user_id",
    "stage" => $modeldata['stage']+1
    );
    $db->insert("leave_requests_accept_reject", $table_data);
    $db->where("id", $app_user_id);
    $userfullname = $db->getValue("user_info", "user_full_name");
      $db->where("id", $app_user_id);
    $username = $db->getValue("user_info", "username");
    $table_data = array(
    "status" => "SENT TO $userfullname($username) FOR APPROVAL" 
    );
    $db->where("id", $rec_id);
    $bool = $db->update("leave_requests", $table_data);
    }else{
    //MAKE READY
    $table_data = array(
    "status" => "LEAVE GRANTED AS PER PROTOCOL OF AUTHORIZATION." 
    );
    $db->where("id", $rec_id);
    $bool = $db->update("leave_requests", $table_data);
    }
}else{
    //reject
$db->where("id='$rec_id'");
    $modeldata = $db->get("leave_requests",999999, "*")[0];
$holiday_type = $modeldata['holiday_type'];
$empid        = $modeldata['emp_id'];
$act          = $modeldata['actual_leave_days'];
$fields = array('id');
$db->where("empid", $empid);
$db->where("leave_type", $holiday_type);
$arr = $db->get("leave_grant", 999999 ,$fields);
// print_r($arr);
// exit();
foreach($arr as $k){
    $id     = $k['id'];
    $params = array($id);
    $bool   = $db->rawQuery("UPDATE leave_grant SET value = value + $act,used=used-$act WHERE id = ?", $params);
    // echo "UPDATE leave_grant SET value = value + $act,used=used-$act WHERE id = ?";
    // exit();
break;
}
    //REJECTED
    $db->where("id", USER_ID);
    $userfullname = $db->getValue("user_info", "user_full_name");
      $db->where("id", USER_ID);
    $username = $db->getValue("user_info", "username");
    $table_data = array(
    "status" => "LEAVE HAS BEEN REJECTED BY $userfullname($username) " 
    );
    $db->where("id", $rec_id);
    $bool = $db->update("leave_requests", $table_data);
}
		# End of after update statement
					$this->set_flash_msg("Record updated successfully", "success");
					return $this->redirect("leave_requests_accept_reject");
				}
				else{
					if($db->getLastError()){
						$this->set_page_error();
					}
					elseif(!$numRows){
						//not an error, but no record was updated
						$page_error = "No record updated";
						$this->set_page_error($page_error);
						$this->set_flash_msg($page_error, "warning");
						return	$this->redirect("leave_requests_accept_reject");
					}
				}
			}
		}
		$db->where("leave_requests_accept_reject.id", $rec_id);;
		$data = $db->getOne($tablename, $fields);
		$page_title = $this->view->page_title = "Edit  Leave Requests Accept Reject";
		if(!$data){
			$this->set_page_error();
		}
		return $this->render_view("leave_requests_accept_reject/edit.php", $data);
	}
	/**
     * Delete record from the database
	 * Support multi delete by separating record id by comma.
     * @return BaseView
     */
	function delete($rec_id = null){
		Csrf::cross_check();
		$request = $this->request;
		$db = $this->GetModel();
		$tablename = $this->tablename;
		$this->rec_id = $rec_id;
		//form multiple delete, split record id separated by comma into array
		$arr_rec_id = array_map('trim', explode(",", $rec_id));
		$db->where("leave_requests_accept_reject.id", $arr_rec_id, "in");
		$bool = $db->delete($tablename);
		if($bool){
			$this->set_flash_msg("Record deleted successfully", "success");
		}
		elseif($db->getLastError()){
			$page_error = $db->getLastError();
			$this->set_flash_msg($page_error, "danger");
		}
		return	$this->redirect("leave_requests_accept_reject");
	}
	/**
     * List page records
     * @param $fieldname (filter record by a field) 
     * @param $fieldvalue (filter field value)
     * @return BaseView
     */
	function list2($fieldname = null , $fieldvalue = null){
		$request = $this->request;
		$db = $this->GetModel();
		$tablename = $this->tablename;
		$fields = array("leave_requests_accept_reject.id", 
			"leave_requests_accept_reject.rec_id", 
			"leave_requests_accept_reject.remark", 
			"leave_requests_accept_reject.stage", 
			"leave_requests_accept_reject.status_acc", 
			"user_info.username AS user_info_username", 
			"user_info.user_full_name AS user_info_user_full_name", 
			"leave_requests_accept_reject.timestamp");
		$pagination = $this->get_pagination(MAX_RECORD_COUNT); // get current pagination e.g array(page_number, page_limit)
		//search table record
		if(!empty($request->search)){
			$text = trim($request->search); 
			$search_condition = "(
				leave_requests_accept_reject.id LIKE ? OR 
				leave_requests_accept_reject.rec_id LIKE ? OR 
				leave_requests_accept_reject.app_userid LIKE ? OR 
				leave_requests_accept_reject.remark LIKE ? OR 
				leave_requests_accept_reject.stage LIKE ? OR 
				leave_requests_accept_reject.status_acc LIKE ? OR 
				user_info.id LIKE ? OR 
				user_info.username LIKE ? OR 
				user_info.password LIKE ? OR 
				user_info.email LIKE ? OR 
				user_info.user_full_name LIKE ? OR 
				user_info.user_role_id LIKE ? OR 
				leave_requests_accept_reject.timestamp LIKE ?
			)";
			$search_params = array(
				"%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%"
			);
			//setting search conditions
			$db->where($search_condition, $search_params);
			 //template to use when ajax search
			$this->view->search_template = "leave_requests_accept_reject/search.php";
		}
		$db->join("user_info", "leave_requests_accept_reject.app_userid = user_info.id", "LEFT");
		if(!empty($request->orderby)){
			$orderby = $request->orderby;
			$ordertype = (!empty($request->ordertype) ? $request->ordertype : ORDER_TYPE);
			$db->orderBy($orderby, $ordertype);
		}
		else{
			$db->orderBy("leave_requests_accept_reject.id", ORDER_TYPE);
		}
		if($fieldname){
			$db->where($fieldname , $fieldvalue); //filter by a single field name
		}
		$tc = $db->withTotalCount();
		$records = $db->get($tablename, $pagination, $fields);
		$records_count = count($records);
		$total_records = intval($tc->totalCount);
		$page_limit = $pagination[1];
		$total_pages = ceil($total_records / $page_limit);
		$data = new stdClass;
		$data->records = $records;
		$data->record_count = $records_count;
		$data->total_records = $total_records;
		$data->total_page = $total_pages;
		if($db->getLastError()){
			$this->set_page_error();
		}
		$page_title = $this->view->page_title = "Leave Requests Accept Reject";
		$this->view->report_filename = date('Y-m-d') . '-' . $page_title;
		$this->view->report_title = $page_title;
		$this->view->report_layout = "report_layout.php";
		$this->view->report_paper_size = "A4";
		$this->view->report_orientation = "portrait";
		$this->render_view("leave_requests_accept_reject/list2.php", $data); //render the full page
	}
}
